/*

PRG Mode by Clifford Helsel 1/14/97 chelsel@spacelab.net

Better than nothing but it could be greatly improved especially with regards to comments

This code is a hacked version of someone else's syntax highlighter for a different
language, perhaps C, although I've lost the original code to provide credit to the
original author.

If you come up with any improvements let me know!

Cliff

*/

#include "eel.h"
#include "c.h"
#include "colcode.h"

color_class text color_scheme "standard-color" green on black;

color_prg_from_here(safe)	// Move backward to the nearest line guaranteed
{							// to start outside any colored region, return pos.
	int pos, limit;			// We know safe is ok value to return.

	limit = point - safe;
	if (color_look_back && color_look_back < limit)
		limit = color_look_back;
	to_begin_line();
	pos = point;
	while ((in_c_comment(limit) & IN_OLD_COMMENT)
				       && search(-1, "/*")) {
		to_begin_line(); // move back out of an old-style comment
		pos = point;
	}
	point = pos;
	while (character(point - 2) == '\\') {	// don't stay on contin line
		point--;
		to_begin_line();
	}
	return point;
}

color_prg_range(from, to)	// recolor just this section
{							// last colored region may go past to
	int t = -1, talk, s;
	char pat[200];

	if (from >= to)
		return to;
	save_var point, matchstart, matchend;
	prg_init_color(from, to);
	point = from;
	talk = (to - from > 2000);	// show status during long delays
	save_var case_fold = 0;
	strcpy(pat, "/<*>|--|[\"']");
	if (!minimal_coloring)
		strcat(pat, "|[A-Za-z_][A-Za-z0-9_]*"
		       "|-?%.?[0-9]([A-Za-z0-9._]|[Ee]-)*");
	while (point < to) {
		if (!re_search(1, pat)) {
			t = size();
			break;
		}
		t = matchstart;
		switch (character(point - 1)) {		// check last char
		case '-':			// found // one-line comment
			nl_forward();
			set_character_color(t, point, color_class c_comment);
			break;
		case '*':			// found /* starting comment
			search(1, "*/");
			set_character_color(t, point, color_class c_comment);
			break;
		case '"':		// found a string literal
			point = t;
			re_search(1, "\"([^\"\\\n]|\\(.|\n))*[\"\n]");
			set_character_color(t, point, color_class c_number);
			if (get_character_color(point, (int *) 0, &s) == 
			    color_class c_number && s > to)  // fix up after
				prg_init_color(point, to = s); // quoted "'s
			break;
		case '\'':		// found a char const
			point = t;
			re_search(1, "\'([^\'\\\n]|\\(.|\n))*[\'\n]");
			set_character_color(t, point, color_class c_charconst);
			break;
		default:		// found identifier, kywd, or number
			set_character_color(t, point, prg_keyword_color(t));
			break;
		}
		if (talk)
			note("Coloring prg program: %d%% complete...",
			     (point - from) * 100 / (to - from));
	}
	prg_init_color(to, t);
	if (talk)
		note("");
	return point;
}

prg_init_color(from, to)
{
	if (from < to)
		set_character_color(from, to, minimal_coloring
				    ? color_class c_function
				    : color_class c_punctuation);
}

prg_keyword_color(from)	// return color for "identifier" from here to point
{						// (something with alpha or digits)
	char buf[500];

	if (point - from > sizeof(buf) - 10)
		save_var point = from + sizeof(buf) - 10;
	buf[0] = '|';		// get identifier, between | chars
	grab(from, point, buf + 1);
	if (index("0123456789-.", buf[1]))
		return prg_number_color(buf + 1);
	strcpy(buf + point - from + 1, "|");
	if (is_prg_keyword(buf))
		return color_class c_function;
	return color_class c_number;
}

is_prg_keyword(p)		// is text in p (must be surrounded by |'s) a keyword?
char *p;
{
	if (strstr(
"|#ENDIF|#IF|#ITSEXPRESSION"
"|#READCLAUSES|#REGION|#SECTION|"
"|#WNAME|.AND.|.F.|"
".NOT.|.OR.|.T.|"
"@FUNCTION|@PROCEDURE|_ALIGNMENT|"
"_BOX|_CALCMEM|_CALCVALUE|"
"_CLIPTEXT|_CUROBJ|_DBLCLICK|"
"_DIARYDATE|_DOS|_GENGRAPH|"
"_GENMENU|_GENPD|_GENSCRN|"
"_GENXTAB|_INDENT|_LMARGIN|"
"_MAC|_MLINE|_PADVANCE|"
"_PAGENO|_PBPAGE|_PCOLNO|"
"_PCOPIES|_PDRIVER|_PDSETUP|"
"_PECODE|_PEJECT|_PEPAGE|"
"_PFORM|_PLENGTH|_PLINENO|"
"_PLOFFSET|_PPITCH|_PQUALITY|"
"_PRETEXT|_PSCODE|_PSCODE|"
"_PSPACING|_PWAIT|_RMARGIN|"
"_TABS|_TALLY|_TEXT|"
"_THROTTLE|_TRANSPORT|_WINDOWS|"
"_WRAP|ABS|ACCEPT|"
"ACCESS|ACOPY|ACOS|"
"ACTIVATE|ADD|ADDITIVE|"
"ADEL|ADIR|AELEMENT|"
"AFIELDS|AFONT|AFTER|"
"AGAIN|AINS|ALEN|"
"ALIAS|ALL|ALLTRIM|"
"ALTERNATE|AMERICAN|AMPM|"
"AND|ANSI|ANSITOOEM|",p) || strstr(
"|APP|APPEND|APPLICATION|"
"ARRAY|AS|ASC|"
"ASCAN|ASCENDING|ASIN|"
"ASORT|ASSIST|ASUBSCRIPT|"
"AT|ATAN|ATC|"
"ATCLINE|ATLINE|ATN|"
"ATN2|AUTO|AUTOMATIC|"
"AUTOSAVE|AVERAGE|AVG|"
"BAR|BEFORE|BEGIN|"
"BELL|BETWEEN|BG|"
"BLANK|BLINK|BLOCKSIZE|"
"BOF|BORDER|BOTTOM|"
"BOX|BR|BREAK|"
"BRITISH|BROWSE|BRSTATUS|"
"BUILD|BY|CALCULATE|"
"CALL|CANCEL|CAPSLOCK|"
"CARRY|CASE|CATALOG|"
"CDOW|CDX|CEILING|"
"CENTER|CENTURY|CGA|"
"CHAIN|CHANGE|CHR|"
"CHRSAW|CHRTRAN|CLEAR|"
"CLOCK|CLOSE|CMONTH|"
"CNT|CNTBAR|CNTPAD|"
"COL|COLOR|COLOUR|"
"COLUMN|COMMAND|COMMIT|"
"COMPACT|COMPATIBILITY|COMPATIBLE|"
"COMPILE|COMPLETED|COMPRESS|"
"CONFIRM|CONSOLE|CONTINUE|"
"CONVERT|COPY|COS|"
"COUNT|CREATE|CTOD|"
"CURDIR|CURRENCY|CURSOR|"
"CYCLE|DATABASE|DATABASES|",p) || strstr(
"|DATE|DAY|DB|"
"DB4|DBASEII|DBDATE|"
"DBF|DBMEMO3|DDEAbortTrans|"
"DDEAdvise|DDEEnabled|DDEExecute|"
"DDEInitiate|DDELastError|DDEPoke|"
"DDERequest|DDESetOption|DDESetService|"
"DDESetTopic|DDETerminate|DEACTIVATE|"
"DEBUG|DECIMALS|DECLARE|"
"DEFAULT|DEFINE|DELETE|"
"DELETED|DELIMITED|DELIMITER|"
"DELIMITERS|DESC|DESCENDING|"
"DESIGN|DEVELOPMENT|DEVICE|"
"DIF|DIFFERENCE|DIMENSION|"
"DIR|DIRECTORY|DISABLE|"
"DISKSPACE|DISPLAY|DISTINCT|"
"DMY|DO|DOHISTORY|",p) || strstr("|DOS|DOUBLE|DOW|"
"DTOC|DTOR|DTOS|"
"ECHO|EDIT|EGA25|"
"EGA43|EJECT|ELSE|"
"ELSEIF|EMPTY|ENABLE|"
"ENCRYPT|ENCRYPTION|END|"
"ENDCASE|ENDDO|ENDFOR|"
"ENDIF|ENDPRINTJOB|ENDSCAN|"
"ENDTEXT|ENVIRONMENT|EOF|"
"ERASE|ERROR|ESCAPE|"
"EVALUATE|EXACT|EXCEPT|"
"EXCLUSIVE|EXIT|EXP|"
"EXPORT|EXTENDED|EXTERNAL|"
"FCHSIZE|FCLOSE|FCOUNT|"
"FCREATE|FEOF|FERROR|"
"FFLUSH|FGETS|FIELD|"
"FIELDS|FILE|FILER|"
"FILES|FILL|FILTER|"
"FIND|FIXED|FKLABEL|"
"FKMAX|FLOAT|FLOCK|"
"FLOOR|FLUSH|FONTMETRIC|",p) || strstr(
"|FOOTER|FOPEN|FOR|"
"FORM|FORMAT|FOUND|"
"FOXPLUS|FOXPRO|FOXQ|"
"FOXSWAP|FPUTS|FREAD|"
"FREEZE|FRENCH|FROM|"
"FSEEK|FSIZE|FULLPATH|"
"FV|FW|FW2|"
"FWRITE|GATHER|GB|"
"GENERAL|GERMAN|GET|"
"GETBAR|GETDIR|GETENV|"
"GETEXPR|GETFILE|GETFONT|"
"GETPAD|GETS|GO|"
"GOMONTH|GOTO|GR|"
"GROUP|GROW|HAVING|"
"HEADER|HEADING|HEIGHT|"
"HELP|HELPFILTER|HIDE|"
"HIGHLIGHT|HISTORY|HOURS|"
"IF|IIF|IMPORT|"
"IN|INDEX|INDEXES|"
"INFORMATION|INKEY|INLIST|"
"INPUT|INSERT|INSMODE|",p) || strstr(
"|INSTRUCT|INT|INTENSITY|"
"INTO|ISALPHA|ISCOLOR|"
"ISDIGIT|ISLOWER|ISMARKED|"
"ISUPPER|ITALIAN|JAPAN|"
"JOIN|KEY|KEYBOARD|"
"KEYCOMP|LABEL|LAST|"
"LASTKEY|LEDIT|LEFT|"
"LEN|LEVEL|LIB|"
"LIBRARY|LIKE|LINE|"
"LINENO|LINKAGE|LIST|"
"LKSYS|LOAD|LOCATE|"
"LOCFILE|LOCK|LOG|"
"LOG10|LOGERRORS|LOGOUT|"
"LOOKUP|LOOP|LOWER|"
"LPARTITION|LTRIM|LUPDATE|"
"MACKEY|MACRO|MACROS|"
"MARGIN|MARK|MASTER|"
"MAX|MCOL|MDOWN|"
"MDX|MDY|MEMLINES|"
"MEMO|MEMORY|MEMOWIDTH|"
"MEMVAR|MENU|MENUS|"
"MESSAGE|MESSAGES|MIN|",p) || strstr(
"|MINIMIZE|MLINE|MOD|"
"MODAL|MODIFY|MODULE|"
"MONO43|MONTH|MOUSE|"
"MOVE|MOVER|MRKBAR|"
"MRKPAD|MROW|MULTI|"
"MULTILOCKS|NDX|NEAR|"
"NETWORK|NEXT|NOALIAS|"
"NOAPPEND|NOCLEAR|NOCLOSE|"
"NOCONSOLE|NODEBUG|NODELETE|"
"NOEDIT|NOEJECT|NOENVIRONMENT|"
"NOFLOAT|NOFOLLOW|NOGROW|"
"NOINIT|NOLGRID|NOLINK|"
"NOLOCK|NOMARGIN|NOMENU|"
"NOMODIFY|NOMOUSE|NONE|"
"NOOPTIMIZE|NOOVERWRITE|NOREFRESH|"
"NORGRID|NORM|NORMAL|"
"NOSAVE|NOSHADOW|NOSHOW|"
"NOT|NOTAB|NOTE|"
"NOTIFY|NOUPDATE|NOWAIT|"
"NOWINDOW|NOZOOM|NPV|"
"NUMBER|NUMLOCK|OBJECT|"
"OBJNUM|OCCURS|ODOMETER|",p) || strstr(
"|OEMTOANSI|OF|OFF|"
"ON|ONKEY|ONLY|"
"OPEN|OPTIMIZE|OR|"
"ORDER|OS|OTHERWISE|"
"OVERWRITE|PACK|PAD|"
"PADC|PADL|PADR|"
"PAGE|PALETTE|PANEL|"
"PARAMETERS|PARTITION|PATH|"
"PAUSE|PAYMENT|PCOL|"
"PDOX|PDRIVER|PDSETUP|"
"PFS|PI|PICTURE|"
"PLAIN|PLAY|POINT|"
"POP|POPUP|POPUPS|"
"PRECISION|PREFERENCE|PREVIEW|"
"PRIMARY|PRINT|PRINTER|"
"PRINTJOB|PRINTSTATUS|PRIVATE|"
"PRMBAR|PRMPAD|PRODUCTION|"
"PROGRAM|PROJECT|PROMPT|"
"PROPER|PROW|PUBLIC|"
"PUSH|PUTFILE|PV|"
"QUERY|QUIT|RAND|",p) || strstr(
"|RANDOM|RANGE|RANK|"
"RAT|RATLINE|RB|"
"RDLEVEL|READ|READERROR|"
"READKEY|RECALL|RECCOUNT|"
"RECNO|RECORD|RECSIZE|"
"REDIT|REFERENCE|REFRESH|"
"REGION|REGIONAL|REINDEX|"
"RELATION|RELATIVE|RELEASE|"
"REMARK|RENAME|REPLACE|"
"REPLICATE|REPORT|REPROCESS|"
"RESET|RESOURCE|REST|"
"RESTORE|RESUME|RETRY|"
"RETURN|RG|RIGHT|"
"RLOCK|ROLLBACK|ROUND|"
"ROW|RPD|RTOD|"
"RTRIM|RUN|SAFETY|"
"SAME|SAMPLE|SAVE|"
"SAY|SCAN|SCATTER|"
"SCHEME|SCOLS|SCOREBOARD|"
"SCREEN|SCROLL|SDF|"
"SECONDARY|SECONDS|SECTION|",p) || strstr(
"|SEEK|SELECT|SELECTION|"
"SEPARATOR|SEQUENCE|SET|"
"SHADOW|SHADOWS|SHELL|"
"SIGN|SIN|SHOW|"
"SIZE|SKIP|SINGLE|"
"SKPPAD|SNAP|SKPBAR|",p) || strstr(
"|SNAPMACRO|SOFTSEEK|SNAPCODE|"
"SOUNDEX|SPACE|SORT|"
"SQRT|SROWS|SQL|"
"STD|STEP|STATUS|"
"STORE|STR|STICKY|"
"STRUCTURE|STUFF|STRTRAN|"
"SUBSTR|SUM|STYLE|"
"SUSPEND|SYLK|SUMMARY|"
"SYSMENU|SYSMETIRC|SYS|"
"TAB|TABLE|SYSTEM|"
"TAG|TALK|TABS|"
"TARGET|TEXT|TAN|"
"TIME|TIMEOUT|TEXTMERGE|"
"TITLES|TO|TITLE|"
"TOPIC|TOTAL|TOP|"
"TRANSFORM|TRAP|TRANSACTION|"
"TRIM|TXTWIDTH|TRBETWEEN|"
"TYPEAHEAD|UDFPARMS|TYPE|"
"UNIQUE|UNLOCK|UNION|"
"UPDATE|UPDATED|UNPACK|"
"USA|USE|UPPER|"
"USER|USERS|USED|"
"VAL|VALID|USING|"
"VALUES|VAR|VALUE|",p) || strstr(
"|VERSION|VGA|VARREAD|"
"VGA50|VIEW|VGA25|"
"WBORDER|WCHILD|WAIT|"
"WEXIST|WFONT|WCOLS|"
"WHERE|WHILE|WHEN|"
"WINDOW|WINDOWS|WIDTH|"
"WK|WK1|WITH|"
"WKS|WLAST|WK3|"
"WLROW|WMAXIMUM|WLCOL|"
"WONTOP|WORKAREA|WMINIMUM|"
"WPARENT|WR|WOUTPUT|"
"WRAP|WREAD|WR1|"
"WROWS|WRK|WTITLE|"
"WVISIBLE|XLS|YEAR|"
"YMD|ZAP|ZOOM|",p) || strstr(
"|#endif|#if|#itsexpression|"
"#readclauses|#region|#section|"
"#wname|.and.|.f.|"
".not.|.or.|.t.|"
"@function|@procedure|_alignment|"
"_box|_calcmem|_calcvalue|"
"_cliptext|_curobj|_dblclick|"
"_diarydate|_dos|_gengraph|"
"_genmenu|_genpd|_genscrn|"
"_genxtab|_indent|_lmargin|"
"_mac|_mline|_padvance|"
"_pageno|_pbpage|_pcolno|"
"_pcopies|_pdriver|_pdsetup|"
"_pecode|_peject|_pepage|"
"_pform|_plength|_plineno|"
"_ploffset|_ppitch|_pquality|"
"_pretext|_pscode|_pscode|"
"_pspacing|_pwait|_rmargin|"
"_tabs|_tally|_text|"
"_throttle|_transport|_windows|"
"_wrap|abs|accept|",p) || strstr(
"|access|acopy|acos|"
"activate|add|additive|"
"adel|adir|aelement|"
"afields|afont|after|"
"again|ains|alen|"
"alias|all|alltrim|"
"alternate|american|ampm|"
"and|ansi|ansitooem|"
"app|append|application|"
"array|as|asc|"
"ascan|ascending|asin|"
"asort|assist|asubscript|"
"at|atan|atc|"
"atcline|atline|atn|"
"atn2|auto|automatic|"
"autosave|average|avg|"
"bar|before|begin|"
"bell|between|bg|"
"blank|blink|blocksize|"
"bof|border|bottom|"
"box|br|break|",p) || strstr(
"|british|browse|brstatus|"
"build|by|calculate|"
"call|cancel|capslock|"
"carry|case|catalog|"
"cdow|cdx|ceiling|"
"center|century|cga|"
"chain|change|chr|"
"chrsaw|chrtran|clear|"
"clock|close|cmonth|"
"cnt|cntbar|cntpad|"
"col|color|colour|"
"column|command|commit|"
"compact|compatibility|compatible|"
"compile|completed|compress|"
"confirm|console|continue|"
"convert|copy|cos|"
"count|create|ctod|"
"curdir|currency|cursor|"
"cycle|database|databases|"
"date|day|db|"
"db4|dbaseii|dbdate|",p) || strstr(
"|dbf|dbmemo3|ddeaborttrans|"
"ddeadvise|ddeenabled|ddeexecute|"
"ddeinitiate|ddelasterror|ddepoke|"
"dderequest|ddesetoption|ddesetservice|"
"ddesettopic|ddeterminate|deactivate|"
"debug|decimals|declare|"
"default|define|delete|"
"deleted|delimited|delimiter|"
"delimiters|desc|descending|"
"design|development|device|"
"dif|difference|dimension|"
"dir|directory|disable|"
"diskspace|display|distinct|"
"dmy|do|dohistory|"
"dos|double|dow|"
"dtoc|dtor|dtos|"
"echo|edit|ega25|"
"ega43|eject|else|"
"elseif|empty|enable|"
"encrypt|encryption|end|"
"endcase|enddo|endfor|",p) || strstr(
"|endif|endprintjob|endscan|"
"endtext|environment|eof|"
"erase|error|escape|"
"evaluate|exact|except|"
"exclusive|exit|exp|"
"export|extended|external|"
"fchsize|fclose|fcount|"
"fcreate|feof|ferror|"
"fflush|fgets|field|"
"fields|file|filer|"
"files|fill|filter|"
"find|fixed|fklabel|"
"fkmax|float|flock|"
"floor|flush|fontmetric|"
"footer|fopen|for|"
"form|format|found|"
"foxplus|foxpro|foxq|"
"foxswap|fputs|fread|"
"freeze|french|from|"
"fseek|fsize|fullpath|"
"fv|fw|fw2|",p) || strstr(
"fwrite|gather|gb|"
"general|german|get|"
"getbar|getdir|getenv|"
"getexpr|getfile|getfont|"
"getpad|gets|go|"
"gomonth|goto|gr|"
"group|grow|having|"
"header|heading|height|"
"help|helpfilter|hide|"
"highlight|history|hours|"
"if|iif|import|"
"in|index|indexes|"
"information|inkey|inlist|"
"input|insert|insmode|"
"instruct|int|intensity|"
"into|isalpha|iscolor|"
"isdigit|islower|ismarked|"
"isupper|italian|japan|"
"join|key|keyboard|"
"keycomp|label|last|"
"lastkey|ledit|left|",p) || strstr(
"len|level|lib|"
"library|like|line|"
"lineno|linkage|list|"
"lksys|load|locate|"
"locfile|lock|log|"
"log10|logerrors|logout|"
"lookup|loop|lower|"
"lpartition|ltrim|lupdate|"
"mackey|macro|macros|"
"margin|mark|master|"
"max|mcol|mdown|"
"mdx|mdy|memlines|"
"memo|memory|memowidth|"
"memvar|menu|menus|"
"message|messages|min|"
"minimize|mline|mod|"
"modal|modify|module|"
"mono43|month|mouse|"
"move|mover|mrkbar|"
"mrkpad|mrow|multi|"
"multilocks|ndx|near|"
"network|next|noalias|"
"noappend|noclear|noclose|",p) || strstr(
"noconsole|nodebug|nodelete|"
"noedit|noeject|noenvironment|"
"nofloat|nofollow|nogrow|"
"noinit|nolgrid|nolink|"
"nolock|nomargin|nomenu|"
"nomodify|nomouse|none|"
"nooptimize|nooverwrite|norefresh|"
"norgrid|norm|normal|"
"nosave|noshadow|noshow|"
"not|notab|note|"
"notify|noupdate|nowait|"
"nowindow|nozoom|npv|"
"number|numlock|object|"
"objnum|occurs|odometer|"
"oemtoansi|of|off|"
"on|onkey|only|"
"open|optimize|or|"
"order|os|otherwise|"
"overwrite|pack|pad|"
"padc|padl|padr|"
"page|palette|panel|",p) || strstr(
"parameters|partition|path|"
"pause|payment|pcol|"
"pdox|pdriver|pdsetup|"
"pfs|pi|picture|"
"plain|play|point|"
"pop|popup|popups|"
"precision|preference|preview|"
"primary|print|printer|"
"printjob|printstatus|private|"
"prmbar|prmpad|production|"
"program|project|prompt|"
"proper|prow|public|"
"push|putfile|pv|"
"query|quit|rand|"
"random|range|rank|"
"rat|ratline|rb|"
"rdlevel|read|readerror|"
"readkey|recall|reccount|"
"recno|record|recsize|"
"redit|reference|refresh|"
"region|regional|reindex|",p) || strstr(
"relation|relative|release|"
"remark|rename|replace|"
"replicate|report|reprocess|"
"reset|resource|rest|"
"restore|resume|retry|"
"return|rg|right|"
"rlock|rollback|round|"
"row|rpd|rtod|"
"rtrim|run|safety|"
"same|sample|save|"
"say|scan|scatter|"
"scheme|scols|scoreboard|"
"screen|scroll|sdf|"
"secondary|seconds|section|"
"seek|select|selection|"
"separator|sequence|set|"
"shadow|shadows|shell|"
"sign|sin|show|"
"size|skip|single|"
"skppad|snap|skpbar|"
"snapmacro|softseek|snapcode|",p) || strstr(
"soundex|space|sort|"
"sqrt|srows|sql|"
"std|step|status|"
"store|str|sticky|"
"structure|stuff|strtran|"
"substr|sum|style|"
"suspend|sylk|summary|"
"sysmenu|sysmetirc|sys|"
"tab|table|system|"
"tag|talk|tabs|"
"target|text|tan|"
"time|timeout|textmerge|"
"titles|to|title|"
"topic|total|top|"
"transform|trap|transaction|"
"trim|txtwidth|trbetween|"
"typeahead|udfparms|type|"
"unique|unlock|union|"
"update|updated|unpack|"
"usa|use|upper|"
"user|users|used|",p) || strstr(
"val|valid|using|"
"values|var|value|"
"version|vga|varread|"
"vga50|view|vga25|"
"wborder|wchild|wait|"
"wexist|wfont|wcols|"
"where|while|when|"
"window|windows|width|"
"wk|wk1|with|"
"wks|wlast|wk3|"
"wlrow|wmaximum|wlcol|"
"wontop|workarea|wminimum|"
"wparent|wr|woutput|"
"wrap|wread|wr1|"
"wrows|wrk|wtitle|"
"wvisible|xls|year|"
"ymd|zap|zoom|" , p))
		return 1;
	return 0;
}

paren_follows() // is there whitespace followed by a "(" at point in buffer?
{		// if so, we assume it's a function name
	for (;; point++) {
		switch (curchar()) {
			case ' ': case '\t':	continue;
			case '(':		return 1;
			default:		return 0;
		}
	}
}

prg_number_color(s)	// return color for number in s
char *s;		// redefine to distinguish different bases
{
	s = s;		// silence eel's warning
	return color_class c_number;
}


command prg_mode()
{
	major_mode = "prg";
	mouse_goes_to_tag = 1;
	strcpy (comment_begin, "REMARK ");
	strcpy (comment_end, " ");
	strcpy (comment_start, "^REMARK +");
	strcpy (comment_pattern, "^REMARK.+");
	comment_column = 0;
	tab_size = 3;
	want_backups = 1;			
	indent_with_tabs = 1;
	recolor_range = color_prg_range;	// set up coloring rules
	recolor_from_here = color_prg_from_here;
	if (want_code_coloring)		// maybe turn on coloring
		when_setting_want_code_coloring();
	make_mode();
/*	color_look_back = 0;
	want_code_coloring = 1;
*/
/*	mode_keys = prg_tab;		*/
/*	over_mode = 1;				*/
/*	display_column = 0;          scroll mode			*/
}

suffix_prg()  { prg_mode(); }

tag_prg_script()
{
	char func[70];
	int start, opoint = point, ofold = case_fold;

	case_fold = 1;
	point = 0;
	while (re_search(1, "^[ \t]*(PROCEDURE |FUNCTION )"))
	{
		re_search(1, "([A-Z0-9_]+)");
		grab(start = find_group(1, 1), find_group(1, 0), func);
		add_tag(func, start);
	};
	case_fold = 1;
	point = 0;
	while (re_search(1, "^[ \t]*(%<%<)"))
	{
		re_search(1, "([A-Z0-9_]+)");
		grab(start = find_group(1, 1), find_group(1, 0), func);
		add_tag(func, start);
	};
	case_fold = 1;
	point = 0;
	while (re_search(1, "^[ \t]*(DECLARE|EXCEPTION)"))
	{
		grab(start = find_group(1, 1), find_group(1, 0), func);
		add_tag(func, start);
	};
	case_fold = 1;
	point = 0;
	while (re_search(1, "^[ \t]*(REMARK )"))
	{
		re_search(1, "([A-Z0-9_]+)");
		grab(start = find_group(1, 1), find_group(1, 0), func);
		add_tag(func, start);
	};

	case_fold = ofold;
	point = opoint;
}	

tag_suffix_prg()
{
	tag_prg_script();
}
